'PIC 16F630   DS18B20
Define CONF_WORD = %00000110010100

AllDigital

' SPI
'CS PORTA.4
Define SPI_CS_REG = PORTA
Define SPI_CS_BIT = 4
'SCK PORTC.5
Define SPI_SCK_REG = PORTC
Define SPI_SCK_BIT = 5
'Din PORTA.5
Define SPI_SDI_REG = PORTA
Define SPI_SDI_BIT = 5
'Dout PORTC.1
Define SPI_SDO_REG = PORTC
Define SPI_SDO_BIT = 1
SPIPrepare

'  
OPTION_REG = %01000000
'  
CMCON = %00000111
' PORTA (/)
TRISA = %00001111
' PORT (/)
TRISC = %00011011

' 
Dim bright As Byte
Read 48, bright

' 
Dim cn(16) As Byte

'  
Dim d(4) As Byte
d(0) = 10
d(1) = 10
d(2) = 10
d(3) = 10

'  
Dim temp As Word
' 
Dim part As Word

'    1-Wire
Define 1WIRE_REG = PORTC
' 
Define 1WIRE_BIT = 2

'    
Dim finish As Bit

Dim i As Byte
Dim j As Byte
Dim s As Byte
Dim n As Byte

' 0 (LSB) scratchpad
Dim lsb As Byte
' 1 (MSB) scratchpad
Dim msb As Byte

'Dim b0 As Byte
'Dim b1 As Byte

'   (  )
Dim stock(4) As Word
stock(1) = 0
stock(2) = 0
stock(3) = 0

'    
Dim sample As Byte
sample = 0

'   stock
Dim index As Byte
index = 0

loop:

	' (  EEPROM) 
	j = 0
	For i = 0 To 3
		n = 3 - i
		n = d(n) * 4
		For s = 0 To 3
			Read n, cn(j)
			j = j + 1
			n = n + 1
		Next s
	Next i
	
	' MAX7219
	SPICSOn  'CS  1
	SPISend %11111100  ' 
	SPISend %00000001
	SPICSOff  'CS  0

	' 
	SPICSOn
	SPISend %11111011
	SPISend %00000111
	SPICSOff

	'
	SPICSOn
	SPISend %11111010
	SPISend bright
	SPICSOff

	'
	SPICSOn
	SPISend %11111001
	SPISend %00000000
	SPICSOff

	'No-op
	SPICSOn
	SPISend %00000000
	SPISend %00000000
	SPICSOff

	'No-op
	SPICSOn
	SPISend %00000000
	SPISend %00000000
	SPICSOff

	' 0 (  )
	SPICSOn
	SPISend %11110001
	SPISend %00000000

	SPISend %11110001
	SPISend cn(7)

	SPISend %11110001
	SPISend cn(8)
	SPICSOff

	' 1
	SPICSOn
	SPISend %11110010
	SPISend cn(3)

	SPISend %11110010
	SPISend cn(6)

	SPISend %11110010
	SPISend %00000000
	SPICSOff

	' 2
	SPICSOn
	SPISend %11110011
	SPISend cn(2)

	SPISend %11110011
	SPISend cn(5)
	
	SPISend %11110011
	SPISend cn(15)
	SPICSOff

	' 3
	SPICSOn
	SPISend %11110100
	SPISend cn(1)

	SPISend %11110100
	SPISend cn(4)

	SPISend %11110100
	SPISend cn(14)
	SPICSOff

	' 4
	SPICSOn
	SPISend %11110101
	SPISend cn(0)

	SPISend %11110101
	SPISend %00000000

	SPISend %11110101
	SPISend cn(13)
	SPICSOff
	
	' 5
	SPICSOn
	SPISend %11110110
	SPISend %00000000

	SPISend %11110110
	SPISend cn(11)

	SPISend %11110110
	SPISend cn(12)
	SPICSOff

	' 6
	SPICSOn
	SPISend %11110111
	SPISend %00000001

	SPISend %11110111
	SPISend cn(10)

	SPISend %11110111
	SPISend %00000000
	SPICSOff

	' 7
	SPICSOn
	SPISend %11111000
	SPISend %00000000

	SPISend %11111000
	SPISend cn(9)

	SPISend %11111000
	SPISend %00000000
	SPICSOff

	'No-op
	SPICSOn
	SPISend %00000000
	SPISend %00000000

	SPISend %00000000
	SPISend %00000000

	SPISend %00000000
	SPISend %00000000
	SPICSOff

	' +1
	If PORTC.4 Then
		If bright < 15 Then
			bright = bright + 1
			Write 48, bright
		Endif
	Endif

	' -1
	If PORTC.3 Then
		If bright > 0 Then
			bright = bright - 1
			Write 48, bright
		Endif
	Endif
	
	'  1-Wire
	1wireInit
	'    
	1wireSendByte 0xcc, 0x44
	WaitMs 1

	'  
	loop2:
	1wireGetBit finish
	If finish = 0 Then Goto loop2

	1wireInit
	'   
	1wireSendByte 0xcc, 0xbe
	'   
	1wireGetByte lsb, msb

	'     
	If lsb = msb Then
		If lsb = 255 Then
			d(0) = 10
			d(1) = 10
			d(2) = 10
			d(3) = 10
			index = 0
			sample = 1
			stock(1) = 0
			stock(2) = 0
			stock(3) = 0
			Goto loop
		Endif
	Endif

	'    
	temp = ShiftRight(lsb, 4)
	n = ShiftLeft(msb, 4)
	temp = temp + n

	'    
	If lsb.3 Then part = 5000 Else part = 0
	If lsb.2 Then part = part + 2500
	If lsb.1 Then part = part + 1250
	If lsb.0 Then part = part + 625

	'
	If msb.7 Then
		temp = 255 - temp + 1
		temp = temp * 10 - part / 1000
	Else
		temp = temp * 10 + part / 1000
	Endif

	'   
	stock(index) = temp
	index = index + 1
	index = index And %00000011
	
	'  
	If sample < 4 Then sample = sample + 1
	temp = (stock(0) + stock(1) + stock(2) + stock(3)) / sample

	d(3) = temp Mod 10
	
	'  ?
	If Not PORTA.1 Then
		If d(3) >= 5 Then temp = temp + 10
		d(3) = 0
	Endif

	d(0) = temp / 1000
	temp = temp Mod 1000
	d(1) = temp / 100

	'  ?
	If d(0) = 0 Then
		d(0) = 11
		If d(1) = 0 Then
			If msb.7 Then
				d(1) = 10
			Else
				d(1) = 11
			Endif
		Else
			If msb.7 Then d(0) = 10
		Endif
	Endif

	temp = temp Mod 100
	d(2) = temp / 10
	
Goto loop

'  
End                                               
